.386

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE

INCLUDE    \masm32\include\windows.inc
INCLUDE    \masm32\include\kernel32.inc
INCLUDE    \masm32\include\comdlg32.inc
INCLUDE    \masm32\include\user32.inc
INCLUDELIB \masm32\lib\kernel32.lib
INCLUDELIB \masm32\lib\comdlg32.lib
INCLUDELIB \masm32\lib\user32.lib

.DATA

AppName       DB "Przykad uruchamiania nr 2", 0
ClassName     DB "SimpleWinClass", 0
SearchFail    DB "Nie mona odnale docelowego procesu", 0
TargetPatched DB "Program naprawiony!", 0
buffer        DW 9090h

.DATA?

DBEvent   DEBUG_EVENT <>
ProcessId DD ?
ThreadId  DD ?

ALIGN DWORD

context CONTEXT <>

.CODE

start:

    INVOKE FindWindow, ADDR ClassName, NULL
    .IF eax!=NULL
        INVOKE GetWindowThreadProcessId, eax, ADDR ProcessId
        mov    ThreadId, eax
        INVOKE DebugActiveProcess, ProcessId

        .WHILE TRUE
            INVOKE WaitForDebugEvent, ADDR DBEvent, INFINITE
            .BREAK .IF DBEvent.dwDebugEventCode==EXIT_PROCESS_DEBUG_EVENT
            .IF DBEvent.dwDebugEventCode==CREATE_PROCESS_DEBUG_EVENT
                mov    context.ContextFlags, CONTEXT_CONTROL
                INVOKE GetThreadContext, DBEvent.u.CreateProcessInfo.hThread,
                                         ADDR context
                INVOKE WriteProcessMemory, DBEvent.u.CreateProcessInfo.hProcess,
                                           context.regEip, ADDR buffer, 2, NULL
                INVOKE MessageBox, 0, ADDR TargetPatched, ADDR AppName,
                                   MB_OK + MB_ICONINFORMATION
            .ELSEIF DBEvent.dwDebugEventCode==EXCEPTION_DEBUG_EVENT
                .IF DBEvent.u.Exception.pExceptionRecord.ExceptionCode==\
                    EXCEPTION_BREAKPOINT
                    INVOKE ContinueDebugEvent, DBEvent.dwProcessId,
                                               DBEvent.dwThreadId,
                                               DBG_CONTINUE    
                    .CONTINUE
                .ENDIF
            .ENDIF
            INVOKE ContinueDebugEvent, DBEvent.dwProcessId,
                                       DBEvent.dwThreadId,
                                       DBG_EXCEPTION_NOT_HANDLED
        .ENDW

    .ELSE
        INVOKE MessageBox, 0, ADDR SearchFail, ADDR AppName,
                           MB_OK + MB_ICONERROR
    .ENDIF
    INVOKE ExitProcess, 0

END start
